import VPlay 1.0
import QtQuick 1.1
import "GravityLogic.js" as Gravity

GameWindow {
  EntityManager {
    id: entityManager
    entityContainer: scene
  }
  Scene {
    id: scene

    PhysicsWorld {
      id: world
    }

    Timer {
      id: gravityTimer
      interval: 100
      repeat: true
      running: false
      onTriggered: {
        Gravity.applyGravity()
      }
    }

    Timer {
      id: emitter
      interval: 1000
      repeat: true
      running: false
      onTriggered: {
        var objectId = entityManager.createEntityFromUrlWithProperties(Qt.resolvedUrl("entities/Object.qml"),{"x":20, "y":scene.height-20})
        Gravity.addObject(objectId)
      }
    }

    Component.onCompleted: {
      Gravity.force = 5
      for(var i = 0; i <4; i++) {
        var planetId = entityManager.createEntityFromUrlWithProperties(Qt.resolvedUrl("entities/Planet.qml"),{"x":100+(Math.random()*(scene.width-100)), "y":Math.random()*scene.height})
        Gravity.addPlanet(planetId)
      }
      gravityTimer.start()
      emitter.start()
    }

    function getThatShitOfMe(planet) {
      Gravity.getThatShitOfMe(planet)
    }

    function removeObject(entity) {
      Gravity.removeObject(entity)
    }
  }
}